// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from foxglove_msgs:msg/FrameTransform.idl
// generated code does not contain a copyright notice
#include "foxglove_msgs/msg/detail/frame_transform__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `parent_frame_id`
// Member `child_frame_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `transform`
#include "foxglove_msgs/msg/detail/transform__functions.h"

bool
foxglove_msgs__msg__FrameTransform__init(foxglove_msgs__msg__FrameTransform * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    foxglove_msgs__msg__FrameTransform__fini(msg);
    return false;
  }
  // parent_frame_id
  if (!rosidl_runtime_c__String__init(&msg->parent_frame_id)) {
    foxglove_msgs__msg__FrameTransform__fini(msg);
    return false;
  }
  // child_frame_id
  if (!rosidl_runtime_c__String__init(&msg->child_frame_id)) {
    foxglove_msgs__msg__FrameTransform__fini(msg);
    return false;
  }
  // transform
  if (!foxglove_msgs__msg__Transform__init(&msg->transform)) {
    foxglove_msgs__msg__FrameTransform__fini(msg);
    return false;
  }
  return true;
}

void
foxglove_msgs__msg__FrameTransform__fini(foxglove_msgs__msg__FrameTransform * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // parent_frame_id
  rosidl_runtime_c__String__fini(&msg->parent_frame_id);
  // child_frame_id
  rosidl_runtime_c__String__fini(&msg->child_frame_id);
  // transform
  foxglove_msgs__msg__Transform__fini(&msg->transform);
}

foxglove_msgs__msg__FrameTransform *
foxglove_msgs__msg__FrameTransform__create()
{
  foxglove_msgs__msg__FrameTransform * msg = (foxglove_msgs__msg__FrameTransform *)malloc(sizeof(foxglove_msgs__msg__FrameTransform));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(foxglove_msgs__msg__FrameTransform));
  bool success = foxglove_msgs__msg__FrameTransform__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
foxglove_msgs__msg__FrameTransform__destroy(foxglove_msgs__msg__FrameTransform * msg)
{
  if (msg) {
    foxglove_msgs__msg__FrameTransform__fini(msg);
  }
  free(msg);
}


bool
foxglove_msgs__msg__FrameTransform__Sequence__init(foxglove_msgs__msg__FrameTransform__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  foxglove_msgs__msg__FrameTransform * data = NULL;
  if (size) {
    data = (foxglove_msgs__msg__FrameTransform *)calloc(size, sizeof(foxglove_msgs__msg__FrameTransform));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = foxglove_msgs__msg__FrameTransform__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        foxglove_msgs__msg__FrameTransform__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
foxglove_msgs__msg__FrameTransform__Sequence__fini(foxglove_msgs__msg__FrameTransform__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      foxglove_msgs__msg__FrameTransform__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

foxglove_msgs__msg__FrameTransform__Sequence *
foxglove_msgs__msg__FrameTransform__Sequence__create(size_t size)
{
  foxglove_msgs__msg__FrameTransform__Sequence * array = (foxglove_msgs__msg__FrameTransform__Sequence *)malloc(sizeof(foxglove_msgs__msg__FrameTransform__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = foxglove_msgs__msg__FrameTransform__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
foxglove_msgs__msg__FrameTransform__Sequence__destroy(foxglove_msgs__msg__FrameTransform__Sequence * array)
{
  if (array) {
    foxglove_msgs__msg__FrameTransform__Sequence__fini(array);
  }
  free(array);
}
